﻿
Imports System.Windows.Forms, System.Collections, System.Drawing

Public Class ControlStyling

	Public Shared Sub StyleControls(frm As Form)
		Dim getChilds As Func(Of Control, IEnumerable) = Function(ctl) ctl.Controls '.Controls
		For Each ctl In getChilds.All(frm)
			Dim grd = TryCast(ctl, DataGridView)
			If grd.NotNull Then
				Dim tbl = TryCast(grd.DataSource, BindingSource)?.DataTable
				If tbl.NotNull Then
					For Each dgvCol As DataGridViewColumn In grd.Columns
						Dim propName = dgvCol.DataPropertyName
						If propName = "" Then Continue For
						Dim dataCol = tbl.Columns(propName)
						If dataCol.DataType = GetType(Decimal) Then
							With dgvCol.DefaultCellStyle
								.Alignment = DataGridViewContentAlignment.MiddleRight
								.Format = "c"
								.Font = New Font("Courier New", If(.Font, If(grd.DefaultCellStyle.Font, grd.Font)).Size)
							End With
							'ElseIf dataCol.DataType = GetType(Double) Then
							'   With dgvCol.DefaultCellStyle
							'      .Alignment = DataGridViewContentAlignment.MiddleRight
							'      .Format = "n2"
							'      .Font = New Font("Courier New", If(.Font, If(grd.DefaultCellStyle.Font, grd.Font)).Size)
							'   End With
						ElseIf dataCol.DataType = GetType(TimeSpan) Then
							With dgvCol.DefaultCellStyle
								.Format = "hh\:mm"
							End With
						End If
					Next
				End If
				grd.RowHeadersWidth = 25
				grd.Attach.UnFocusedSelectionColor()
				grd.CellBorderStyle = DataGridViewCellBorderStyle.None
				AddHandler grd.KeyDown, AddressOf DatagridViewBehavior.DefaultValueOnDelete_KeyDown
			End If
			Dim tb = TryCast(ctl, TextBox)
			If tb.NotNull Then
				' man kann hier auch andere Controls stylen, nicht nur DGV
			End If
		Next
	End Sub

End Class
