﻿#Region "FileHeader"
#If False Then
Zustandsbehaftete "Behaviors" für BindingSource

• HierarchicalSort(): bewirkt, dass 2-spaltig hierarchisch sortiert wird, wenn man nacheinander mehrere ColumnHeaders klickst. Dabei wird die letzt-geklickste Spalte jeweils zur Haupt-Sortier-Spalte 

• RestoreCurrent(): Beim Umschalten der Sortierung wird der vorher selektete Datensatzes an seiner neuen Position wieder aufgesucht

#End If '-- Options, Imports
Imports System.ComponentModel
Imports System.Runtime.CompilerServices
#End Region 'FileHeader

Namespace System.Windows.Forms

   Public Class BindingSourceAttach

      Friend Shared ReadOnly Attaches As New ComponentProperty(Of BindingSource, BindingSourceAttach)(Function(bs) New BindingSourceAttach(bs))

      Private WithEvents _Bs, _Hierarchical, _Restoring As BindingSource
      Public Sub New(bs As BindingSource)
         Me._Bs = bs
      End Sub

      Public Function HierarchicalSort(Optional value As Boolean = True) As BindingSourceAttach
         _Hierarchical = If(value, _Bs, Nothing)
         Return Me
      End Function
      Public Function RestoreCurrent(Optional value As Boolean = True) As BindingSourceAttach
         _Restoring = If(value, _Bs, Nothing)
         If value Then Dim rw = _Bs.At : _RecentCurrentRows = {rw, rw}
         Return Me
      End Function

      Private _RecentCurrentRows(1) As DataRow
      Private Sub Restoring_CurrentChanged(sender As Object, e As EventArgs) Handles _Restoring.CurrentChanged
         _RecentCurrentRows(0) = _RecentCurrentRows(1) : _RecentCurrentRows(1) = _Bs.At
      End Sub
      Private Sub Restoring_ListChanged(sender As Object, e As ListChangedEventArgs) Handles _Restoring.ListChanged
         If e.ListChangedType <> ListChangedType.Reset Then Return
         Application.OpenForms(0).BeginInvoke(Sub() _Bs.MoveTo(_RecentCurrentRows(0)))
      End Sub

      Private _RecentSorts() As String
      Private Sub Hirarchical_ListChanged(sender As Object, e As ListChangedEventArgs) Handles _Hierarchical.ListChanged
         If e.ListChangedType <> ListChangedType.Reset Then Return
         Dim dv = DirectCast(_Bs.List, DataView)
         Dim sort = dv.Sort  ' Beispiel: dv.Sort = "[Zweiteiliger ColumnName] DESC"
         If sort = "" Then Return
         If _RecentSorts Is Nothing Then _RecentSorts = {sort, sort}
         Dim sortCol = sort.Split("]"c)(0) ' erste Sortierspalte
         If sortCol <> _RecentSorts(0).Split("]"c)(0) Then _RecentSorts(1) = _RecentSorts(0)
         _RecentSorts(0) = sort.Split(","c)(0) ' erste Sortierung - kann 'DESC' enthalten
         Dim DoubletteFree = _RecentSorts.Where(Function(s, i) i = 0 OrElse s.Split("]"c)(0) <> sortCol)
         sort = String.Join(", ", DoubletteFree)
         If dv.Sort <> sort Then dv.Sort = sort ' Beispiel neu: dv.Sort = "[Zweiteiliger ColumnName] DESC,[VorherigeColumn]"
         'Diagnostics.Debug.Print(dv.Sort)
      End Sub

   End Class

   <EditorBrowsable(System.ComponentModel.EditorBrowsableState.Never)> _
   Public Module modBindingSourceAttach
      <Extension> _
      Public Function Attach(bs As BindingSource) As BindingSourceAttach
         Return BindingSourceAttach.Attaches(bs)
      End Function
   End Module

End Namespace
